#ifndef __TaylorsData_ArticleMetaItem_h__
#define __TaylorsData_ArticleMetaItem_h__

#include <TaylorsData/TaylorsData.h>

#include <TaylorsData/Base.h>
#include <TaylorsData/Exception.h>
#include <TaylorsData/MetaItem.h>

#include <string>
#include <map>

namespace TaylorsData
{
	class TaylorsData_Export ArticleMetaItem : public Base
	{
		public:
			class TaylorsData_Export Key
			{
				private:
					int _nArticleId;
					std::string _strMetaItem;

				public:
					Key();
					Key( int nArticleId, const MetaItem& metaItem );
					Key( const Key& key );
					virtual ~Key();

					const Key& operator=( const Key& key );
					bool operator==( const Key& key ) const;
					bool operator!=( const Key& key ) const;
					bool operator<( const Key& key ) const;

					int articleId() const;
					const MetaItem& metaItem() const;
			};

		private:
			Key _key;
			std::string _strValue;

		public:
			ArticleMetaItem();
			ArticleMetaItem( const Key& key );
			ArticleMetaItem(const ArticleMetaItem& item );
			virtual ~ArticleMetaItem();

			const ArticleMetaItem operator=( const ArticleMetaItem& item );

			const Key& key() const;
			const std::string& value() const;

			void setValue( const std::string& strValue );

			static ArticleMetaItem fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db );
//			static ArticleMetaItem create( const ArticleMetaItem& item, RfcDal::DalDatabase& conn );
			virtual void update( RfcDal::DalDatabase& conn );
	};

	class TaylorsData_Export ArticleMetaItemMap : public std::map<ArticleMetaItem::Key, ArticleMetaItem>
	{
		public:
			static ArticleMetaItemMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db );
	};
}

#endif /* !__TaylorsData_ArticleMetaItem_h__ */
