#ifndef __TaylorsData_Glossary_h__
#define __TaylorsData_Glossary_h__

#include <TaylorsData/TaylorsData.h>

#include <TaylorsData/GlossaryEntry.h>
#include <TaylorsData/GlossaryText.h>

#include <librfcdal/DalDatabase.h>

#include <string>
#include <map>

namespace TaylorsData
{
	class TaylorsData_Export Glossary
	{
		private:
			GlossaryEntryMap _entryS;

		public:
			void load( RfcDal::DalDatabase& db );
			GlossaryEntryMap& entrys();
			GlossaryEntryPtrMap entrys( const std::string& strReplacement, bool bCaseSensitive = true );

			GlossaryTextList evaluate( const std::string& strText );

			GlossaryText check( const std::string& strText );

			std::string translate( const std::string& strSource );

		protected:
			GlossaryText checkId( const std::string &strText );
			GlossaryText checkText( const std::string &strText );
	};
}

#endif /* !__TaylorsData_Glossary_h__ */
