#ifndef __TaylorsData_GlossaryText_h__
#define __TaylorsData_GlossaryText_h__

#include <TaylorsData/TaylorsData.h>

#include <TaylorsData/GlossaryEntry.h>

#include <vector>

namespace TaylorsData
{
	class TaylorsData_Export GlossaryText
	{
		public:
			enum Mode{ nothing, goodGlossary, badGlossary, hasGlossary, hasMultiGlossary };

		private:
			int _nBegin;
			int _nLength;
			Mode _mode;
			TaylorsData::GlossaryEntryPtrMap _entryS;

		public:
			GlossaryText();
			GlossaryText( int nBegin, int nLength, Mode mode, const GlossaryEntryPtrMap& entryS );
			GlossaryText( const GlossaryText& text );
			virtual ~GlossaryText();

			GlossaryText& operator=( const GlossaryText& text );

			int begin() const;
			int length() const;
			Mode mode() const;
			const GlossaryEntryPtrMap& entrys() const;
	};

	class TaylorsData_Export GlossaryTextList : public std::vector<GlossaryText>
	{
	};
}

#endif /* !__TaylorsData_GlossaryText_h__ */
