#ifndef __TaylorsData_Settings_h__
#define __TaylorsData_Settings_h__

#include <TaylorsData/TaylorsData.h>
#include <TaylorsData/Exception.h>

#include <string>
#include <map>
#include <set>

class QMainWindow;

namespace TaylorsData
{
	class TaylorsData_Export ToolMap : public std::map<std::string, QMainWindow*(*)()>
	{
	};

	class TaylorsData_Export ToolSet : public std::set<std::string>
	{
	};

	class TaylorsData_Export Settings
	{
		private:
			static std::string _strFile;
			static std::string _strDefaultReport;
			static ToolSet _objectS;
			static ToolMap _toolS;

		public:
			static void load( const std::string& strFile );
			static void loadTool( const std::string& strSO );

			static const std::string& defaultReport();
			static const ToolSet& objects();
			static const ToolMap& tools();

			static void setDefaultReport( const std::string& strReport );
			static void addObject( const std::string& strSO );
			static void removeObject( const std::string& strSO );

			static void save();
	};
}

#endif // __TaylorsData_Settings_h__
