#ifndef __TaylorsData_Site_h__
#define __TaylorsData_Site_h__

#include <TaylorsData/TaylorsData.h>

#include <TaylorsData/Base.h>

#include <librfcdal/DalDatabase.h>

#include <string>
#include <map>

namespace TaylorsData
{
	class TaylorsData_Export Site : public Base
	{
		public:
			class TaylorsData_Export Key
			{
				private:
					std::string _strSite;

				public:
					Key();
					Key( const std::string& strSite );
					Key( const Key& key );
					virtual ~Key();

					const Key& operator=( const Key& key );
					bool operator==( const Key& key ) const;
					bool operator!=( const Key& key ) const;
					bool operator<( const Key& key ) const;

					const std::string& site() const;
			};

		private:
			Key _key;
			std::string _strDescription;

		public:
			Site();
			Site( const Key& key );
			Site( const Site& site );
			virtual ~Site();

			const Site& operator=( const Site& site );

			const Key& key() const;
			const std::string& description() const;

			void setDescription( const std::string& strDescription );

			static Site fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db );
			static Site create( const Site& site, RfcDal::DalDatabase& conn );
			virtual void update( RfcDal::DalDatabase& conn );
	};

	class SiteMap : public std::map<Site::Key, Site>
	{
		public:
			static SiteMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db );
	};
};

#endif /* !__TaylorsData_Site_h__ */
