#ifndef __TaylorsData_Variant_h__
#define __TaylorsData_Variant_h__

#include <TaylorsData/TaylorsData.h>

#include <Base4c/Date.h>

#include <string>

namespace TaylorsData
{
	class Variant
	{
		public:
			enum Type{ typeNone, typeString, typeInt, typeDouble, typeDate };

		private:
			Type _type;
			std::string _strValue;
			int _nValue;
			double _dValue;
			Base4c::Date _dtValue;

		public:
			Variant();
			Variant( const std::string& strValue );
			Variant( int nValue );
			Variant( double dValue );
			Variant( const Base4c::Date& dtValue );
			Variant( const Variant& varValue );
			virtual ~Variant();

			const Variant& operator=( const Variant& varValue );

			Type type() const;
			std::string asString() const;
			int asInt() const;
			double asDouble() const;
			Base4c::Date asDate() const;
	};
}

#endif /* !__TaylorsData_Variant_h__ */
