#ifndef ARTICLECOLLECTIONWIDGET_H
#define ARTICLECOLLECTIONWIDGET_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>

#include <TaylorsData/Article.h>

#include <QTreeWidget>
#include <QListWidget>
#include <QResizeEvent>

namespace TaylorsUIComponents
{
	class ArticleCollectionWidget : public QWidget
	{
		Q_OBJECT

		public:
			enum ViewMode{ viewIcon, viewList, viewDetail };

		private:
			QTreeWidget* _ptree;
			QListWidget* _plist;
			ViewMode _viewMode;

		public:
			explicit ArticleCollectionWidget( QWidget *parent = 0 );

			void populate( TaylorsData::ArticlePtrMap& articleS );
			void setViewMode( ViewMode mode );
			TaylorsData::Article::KeySet selectedItems();

		signals:
			void articleDoubleClicked( TaylorsData::Article& article );
			void exportArticles( TaylorsData::Article::KeySet& keyS );

		protected slots:
			void onCMReqArticle( const QPoint& pt );
			void onDblClickList( QListWidgetItem* pitem );
			void onDblClickTree( QTreeWidgetItem* pitem, int nCol );

		protected:
			virtual void resizeEvent( QResizeEvent* pe );
	};
}

#endif // ARTICLECOLLECTIONWIDGET_H
