#ifndef ARTICLEWIDGET_H
#define ARTICLEWIDGET_H

#include <CategoryTreeWidgetItem.h>

#include <TaylorsData/Article.h>

#include <QWidget>

namespace Ui
{
	class ArticleWidget;
}

namespace TaylorsUIComponents
{
	class ArticleWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::ArticleWidget *ui;
			TaylorsData::Article* _particle;

		public:
			explicit ArticleWidget(QWidget *parent = 0);
			~ArticleWidget();

			void setArticle( TaylorsData::Article& article );
			void save();

		protected slots:
			void onCategoryItemChanged( QTreeWidgetItem* pitem, int nCol );
			void onActivatedShape( int nIndex );
			void onClickedInventoryNo();
			void onEditInventoryNo( const QString& strText );
			void onChangedStatus( const TaylorsData::Status& status );
	};
}

#endif // ARTICLEWIDGET_H
