#ifndef CATEGORYTREEWIDGET_H
#define CATEGORYTREEWIDGET_H

#include <CategoryTreeWidgetItem.h>

#include <TaylorsData/Article.h>

#include <QTreeWidget>

namespace TaylorsUIComponents
{
	class CategoryTreeWidget : public QTreeWidget
	{
		Q_OBJECT

		public:
			class CategoryCategoryTreeWidgetItemMap : public std::map<TaylorsData::Category::Key, CategoryTreeWidgetItem*>
			{
			};

		private:
			CategoryCategoryTreeWidgetItemMap _categoryCategoryTreeWidgetItemS;
			TaylorsData::Article* _particle;

		public:
			explicit CategoryTreeWidget(QWidget *parent = 0);

			void addItem( CategoryTreeWidgetItem* pparent, TaylorsData::Category* pcategory );

			void setArticle( TaylorsData::Article& article );

			CategoryTreeWidgetItem* itemFor( const TaylorsData::Category& category );

		signals:
			void categoryClicked( TaylorsData::Category& category );
			void categoryDoubleClicked( TaylorsData::Category& category );

		protected slots:
			void onItemClicked( QTreeWidgetItem* pitem, int nCol );
			void onItemDoubleClicked( QTreeWidgetItem* pitem, int nCol );
	};
}

#endif // CATEGORYTREEWIDGET_H
