#ifndef CLASSIFICATIONWIDGET_H
#define CLASSIFICATIONWIDGET_H

#include <TaylorsData/Category.h>

#include <QWidget>

class QTreeWidgetItem;

namespace Ui
{
	class ClassificationWidget;
}

namespace TaylorsUIComponents
{
	class ClassificationWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::ClassificationWidget *ui;
			TaylorsData::Category* _pcategory;
			TaylorsData::Category _category;
			bool _bCreating;

		public:
			explicit ClassificationWidget(QWidget *parent = 0);
			~ClassificationWidget();

		protected:
			void setReorder( QTreeWidgetItem* pitem );

		protected slots:
			void onCategoryClicked( TaylorsData::Category& category );
			void onCategoryClicked( QTreeWidgetItem* pitem, int );
			void onCMReqCategory( const QPoint& pt );
			void onUp();
			void onDown();
			void onSave();
	};
}

#endif // CLASSIFICATIONWIDGET_H
