#ifndef CUSTOMERTREEWIDGET_H
#define CUSTOMERTREEWIDGET_H

#include <TaylorsData/Customer.h>

#include <QTreeWidget>

namespace TaylorsUIComponents
{
	class CustomerTreeWidgetItem;

	class CustomerTreeWidget : public QTreeWidget
	{
		Q_OBJECT

		public:
			class CustomerCustomerTreeWidgetItemMap : public std::map<TaylorsData::Customer::Key, CustomerTreeWidgetItem*>
			{
			};

		private:
			CustomerCustomerTreeWidgetItemMap _customerS;

		public:
			explicit CustomerTreeWidget(QWidget *parent = 0);

			void refresh();
			CustomerTreeWidgetItem* addItem( TaylorsData::Customer& customer );
			CustomerTreeWidgetItem* itemFor( const TaylorsData::Customer::Key& key );

		signals:
			void customerClicked( TaylorsData::Customer& );
			void customerDoubleClicked( TaylorsData::Customer& );

		protected slots:
			void onItemClicked( QTreeWidgetItem* pitem, int nCol );
			void onItemDoubleClicked( QTreeWidgetItem* pitem, int nCol );

		public slots:
			virtual void clear();
	};
}

#endif // CUSTOMERTREEWIDGET_H
