#ifndef GLOSSARYWIDGET_H
#define GLOSSARYWIDGET_H

#include <TaylorsData/GlossaryEntry.h>

#include <QWidget>
#include <QListWidget>

namespace Ui
{
	class GlossaryWidget;
}

namespace TaylorsUIComponents
{
	class GlossaryListWidgetItem : public QListWidgetItem
	{
		private:
			TaylorsData::GlossaryEntry& _entry;

		public:
			GlossaryListWidgetItem( QListWidget* plist, TaylorsData::GlossaryEntry& entry );

			TaylorsData::GlossaryEntry& entry();
	};

	class GlossaryWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::GlossaryWidget *ui;
			TaylorsData::GlossaryEntry* _pentry;
			bool _bCreating;

		public:
			explicit GlossaryWidget(QWidget *parent = 0);
			~GlossaryWidget();

		protected slots:
			void onNew();
			void onSave();
			void onClickedEntry( QListWidgetItem* pitem);
	};
}

#endif // GLOSSARYWIDGET_H
