#ifndef LOCATIONTREEWIDGET_H
#define LOCATIONTREEWIDGET_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>

#include <TaylorsUIComponents/LocationTreeWidgetItem.h>

#include <TaylorsData/Location.h>
#include <TaylorsData/SubLocation.h>

#include <QTreeWidget>

#include <map>

namespace TaylorsUIComponents
{
	class TAYLORSUICOMPONENTSSHARED_EXPORT LocationTreeWidget : public QTreeWidget
	{
		Q_OBJECT

		public:
			class LocationLocationTreeWidgetItemMap : public std::map<TaylorsData::Location::Key, LocationTreeWidgetItem*>
			{
			};

		private:
			LocationLocationTreeWidgetItemMap _locationS;

		public:
			explicit LocationTreeWidget(QWidget *parent = 0);

			LocationTreeWidgetItem* addItem( TaylorsData::Location& location );
			SubLocationTreeWidgetItem* addItem( TaylorsData::SubLocation& subLocation );

			LocationTreeWidgetItem* itemFor( const TaylorsData::Location::Key& key );
			SubLocationTreeWidgetItem* itemFor( const TaylorsData::SubLocation::Key& key );

		signals:
			void locationClicked( TaylorsData::Location& location );
			void subLocationClicked( TaylorsData::SubLocation& subLocation );
			void locationDoubleClicked( TaylorsData::Location& location );
			void subLocationDoubleClicked( TaylorsData::SubLocation& subLocation );

		protected slots:
			void onItemClicked( QTreeWidgetItem* pitem, int nCol );
			void onItemDoubleClicked( QTreeWidgetItem* pitem, int nCol );

		public slots:
			virtual void clear();
	};
}

#endif // LOCATIONTREEWIDGET_H
