#ifndef LOCATIONTREEWIDGETITEM_H
#define LOCATIONTREEWIDGETITEM_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>

#include <TaylorsData/Location.h>
#include <TaylorsData/SubLocation.h>

#include <QTreeWidgetItem>

namespace TaylorsUIComponents
{
	class LocationTreeWidget;
	class SubLocationTreeWidgetItem;

	class TAYLORSUICOMPONENTSSHARED_EXPORT LocationTreeWidgetItem : public QTreeWidgetItem
	{
		public:
			class SubLocationSubLocationTreeWidgetItemMap : public std::map<TaylorsData::SubLocation::Key, SubLocationTreeWidgetItem*>
			{
			};

		private:
			TaylorsData::Location& _location;
			SubLocationSubLocationTreeWidgetItemMap _subLocationS;

		protected:
			LocationTreeWidgetItem( LocationTreeWidget* ptree, TaylorsData::Location& location );

			friend class LocationTreeWidget;

		public:
			void refresh();
			SubLocationTreeWidgetItem* addItem( TaylorsData::SubLocation& location );
			SubLocationTreeWidgetItem* itemFor( const TaylorsData::SubLocation::Key& key );

			TaylorsData::Location& location();
	};

	class TAYLORSUICOMPONENTSSHARED_EXPORT SubLocationTreeWidgetItem : public QTreeWidgetItem
	{
		private:
			TaylorsData::SubLocation& _subLocation;

		protected:
			SubLocationTreeWidgetItem( LocationTreeWidgetItem* pparent, TaylorsData::SubLocation& subLocation );

			friend class LocationTreeWidgetItem;

		public:
			void refresh();

			TaylorsData::SubLocation& subLocation();
	};
}

#endif // LOCATIONTREEWIDGETITEM_H
