#ifndef LOCATIONWIDGET_H
#define LOCATIONWIDGET_H

#include <TaylorsData/Location.h>
#include <TaylorsData/SubLocation.h>

#include <QWidget>

namespace Ui
{
	class LocationWidget;
}

namespace TaylorsUIComponents
{
	class LocationWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::LocationWidget *ui;
			const TaylorsData::Location* _plocation;
			const TaylorsData::SubLocation* _psubLocation;

		public:
			explicit LocationWidget(QWidget *parent = 0);
			~LocationWidget();

			void setLocation( const TaylorsData::Location& location );
			void setSubLocation( const TaylorsData::SubLocation& subLocation );

			bool hasSubLocation() const;

			const TaylorsData::Location& location();
			const TaylorsData::SubLocation& subLocation();

		protected slots:
			void onSelChangeLocation( int nCurrentIndex );
			void onSelChangeSubLocation( int nCurrentIndex );
	};
}

#endif // LOCATIONWIDGET_H
