#ifndef METAITEMTREEWIDGET_H
#define METAITEMTREEWIDGET_H

#include <MetaItemTreeWidgetItem.h>

#include <TaylorsData/Article.h>

#include <QTreeWidget>

namespace TaylorsUIComponents
{
	class MetaItemTreeWidget : public QTreeWidget
	{
		Q_OBJECT

		public:
			class MetaItemMetaItemTreeWidgetItemMap : public std::map<TaylorsData::MetaItem::Key, MetaItemTreeWidgetItem*>
			{
			};

		private:
			MetaItemMetaItemTreeWidgetItemMap _metaItemMetaItemTreeWidgetItemS;
			TaylorsData::Article* _particle;

		public:
			explicit MetaItemTreeWidget(QWidget *parent = 0);

			void addItem( MetaItemTreeWidgetItem* pparent, const TaylorsData::MetaItem* pitem );

			void setArticle( TaylorsData::Article& article );

		protected slots:
			void onItemDoubleClicked( QTreeWidgetItem* pitem, int nCol );
	};
}

#endif // METAITEMTREEWIDGET_H
