#ifndef SITEWIDGET_H
#define SITEWIDGET_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>

#include <TaylorsData/Site.h>
#include <TaylorsData/Exception.h>

#include <QWidget>
#include <QListWidgetItem>

namespace Ui
{
	class SiteWidget;
}

namespace TaylorsUIComponents
{
	class TAYLORSUICOMPONENTSSHARED_EXPORT SiteListWidgetItem : public QListWidgetItem
	{
		private:
			TaylorsData::Site* _ptype;

		public:
			SiteListWidgetItem( TaylorsData::Site& type, QListWidget* pwidget = NULL );

			TaylorsData::Site& site();
	};

	class TAYLORSUICOMPONENTSSHARED_EXPORT SiteWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::SiteWidget *ui;
			TaylorsData::Site* _ptype;
			bool _bNew;
			TaylorsData::Site _typeTemp;

		public:
			explicit SiteWidget(QWidget *parent = 0);
			~SiteWidget();

		protected slots:
			void onClickedSite( QListWidgetItem* pitem );
			void onCMRequested( const QPoint& pt );
			void onSave();
	};
}

#endif // SITEWIDGET_H
