#ifndef STATUSCOMBOBOX_H
#define STATUSCOMBOBOX_H

#include <TaylorsData/Status.h>

#include <QComboBox>

namespace TaylorsUIComponents
{
	class StatusComboBox : public QComboBox
	{
		Q_OBJECT

		private:
			const TaylorsData::Status* _pstatus;

		public:
			explicit StatusComboBox(QWidget *parent = 0);
			virtual ~StatusComboBox();

			void setStatus( const TaylorsData::Status& status );

			const TaylorsData::Status& status();

		protected slots:
			void onSelChangeStatus( int nIndex );

		signals:
			void statusClicked( const TaylorsData::Status& );
	};
}

#endif // STATUSCOMBOBOX_H
