#ifndef STATUSTREEWIDGET_H
#define STATUSTREEWIDGET_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>

#include <TaylorsData/Status.h>

#include <QTreeWidget>

namespace TaylorsUIComponents
{
	class StatusTreeWidgetItem;

	class TAYLORSUICOMPONENTSSHARED_EXPORT StatusTreeWidget : public QTreeWidget
	{
		Q_OBJECT

		public:
			class TAYLORSUICOMPONENTSSHARED_EXPORT StatusStatusTreeWidgetItemMap : public std::map<TaylorsData::Status::Key, StatusTreeWidgetItem*>
			{
			};

		private:
			StatusStatusTreeWidgetItemMap _statusS;

		public:
			explicit StatusTreeWidget(QWidget *parent = 0);

			void addItem( TaylorsData::Status& status );
			StatusTreeWidgetItem* itemFor( const TaylorsData::Status::Key& key );

		signals:
			void statusClicked( TaylorsData::Status& );
			void statusDoubleClicked( TaylorsData::Status& );

		public slots:
			void onItemClicked( QTreeWidgetItem* pitem, int nCol );
			void onItemDoubleClicked( QTreeWidgetItem* pitem, int nCol );
	};
}

#endif // STATUSTREEWIDGET_H
