#ifndef SUBLOCATIONWIDGET_H
#define SUBLOCATIONWIDGET_H

#include <TaylorsUIComponents/TaylorsUIComponents.h>


#include <TaylorsData/Location.h>
#include <TaylorsData/SubLocation.h>

#include <QWidget>

namespace Ui
{
	class SubLocationWidget;
}

namespace TaylorsUIComponents
{
	class TAYLORSUICOMPONENTSSHARED_EXPORT SubLocationWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::SubLocationWidget *ui;
			TaylorsData::Location* _plocation;
			TaylorsData::Location _location;
			TaylorsData::SubLocation* _psubLocation;
			TaylorsData::SubLocation _subLocation;
			bool _bCreating;

		public:
			explicit SubLocationWidget(QWidget *parent = 0);
			~SubLocationWidget();

		protected slots:
			void onClickedLocation( TaylorsData::Location& location );
			void onClickedSubLocation( TaylorsData::SubLocation& subLocation );
			void onSave();
			void onCMReqLocation( const QPoint& pt );
			void onExport();
	};
}

#endif // SUBLOCATIONWIDGET_H
