#ifndef TAYLORSCOMPOUNDEXCEPTIONDIALOG_H
#define TAYLORSCOMPOUNDEXCEPTIONDIALOG_H

#include <TaylorsData/Exception.h>

#include <QDialog>
#include <QListWidgetItem>

namespace Ui
{
	class TaylorsCompoundExceptionDialog;
}

namespace TaylorsUIComponents
{
	class TaylorsCompoundExceptionDialog : public QDialog
	{
		public:
			class ExceptionListWidgetItem : public QListWidgetItem
			{
				private:
					const TaylorsData::Exception& _e;

				public:
					ExceptionListWidgetItem( QListWidget* pparent, const TaylorsData::Exception& e );

					const TaylorsData::Exception& e() const;
			};

		Q_OBJECT

		private:
			Ui::TaylorsCompoundExceptionDialog *ui;
			const TaylorsData::CompoundException& _e;

		public:
			explicit TaylorsCompoundExceptionDialog(QWidget *parent, const TaylorsData::CompoundException& e );
			~TaylorsCompoundExceptionDialog();

		protected slots:
			void onDblClickException( QListWidgetItem* pitem );
	};
}

#endif // TAYLORSCOMPOUNDEXCEPTIONDIALOG_H
